gtkmm: Gtk::Filter Class Reference

gtkmm 4.23.2

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::Filter Class Reference
ListView Classes

Filtering items. More...

`#include <gtkmm/filter.h>`

Inheritance diagram for Gtk::Filter:
[legend]

## Public Types
enum class | Match { Match::SOME , Match::NONE , Match::ALL }
| Describes the known strictness of a filter. More...
enum class | Change { Change::DIFFERENT , Change::LESS_STRICT , Change::MORE_STRICT , Change::DIFFERENT_REWATCH , Change::LESS_STRICT_REWATCH , Change::MORE_STRICT_REWATCH }
| Describes changes in a filter in more detail and allows objects using the filter to optimize refiltering items. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Public Member Functions
| Filter (Filter && src) noexcept
Filter & | operator= (Filter && src) noexcept
| ~Filter () noexcept override
GtkFilter * | gobj ()
| Provides access to the underlying C GObject.
const GtkFilter * | gobj () const
| Provides access to the underlying C GObject.
GtkFilter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | match (const Glib::RefPtr< Glib::ObjectBase > & item)
| Checks if the given item is matched by the filter or not.
Match | get_strictness ()
| Gets the known strictness of a filter.
Glib::SignalProxy< void(Change)> | signal_changed ()
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| Filter ()
void | changed (Change change=Change::DIFFERENT)
| Notifies all users of the filter that it has changed.
virtual bool | match_vfunc (const Glib::RefPtr< Glib::ObjectBase > & item)
virtual Match | get_strictness_vfunc ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::Filter > | wrap (GtkFilter * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Filtering items.

A Gtk::Filter object describes the filtering to be performed by a Gtk::FilterListModel.

The model will use the filter to determine if it should include items or not by calling match() for each item and only keeping the ones that the function returns true for.

Filters may change what items they match through their lifetime. In that case, they will emit the signal_changed() signal to notify that previous filter results are no longer valid and that items should be checked again via match().

GTK provides various pre-made filter implementations for common filtering operations. These filters often include properties that can be linked to various widgets to easily allow searches.

However, in particular for large lists or complex search methods, it is also possible to subclass Gtk::Filter and provide one's own filter.

See also
  Gtk::FilterListModel

Since gtkmm 3.98

## Constructor & Destructor Documentation

## ◆ Filter() [1/2]

Gtk::Filter::Filter | ( | Filter && | src | ) |
| noexcept

## ◆ ~Filter()

Gtk::Filter::~Filter | ( |  | ) |
| overridenoexcept

## ◆ Filter() [2/2]

Gtk::Filter::Filter | ( |  | ) |
| protected

## Member Function Documentation

## ◆ changed()

void Gtk::Filter::changed | ( | Change | change = Change::DIFFERENT | ) |
| protected

Notifies all users of the filter that it has changed.

This emits the signal_changed() signal. Users of the filter should then check items again via match().

Depending on the change parameter, not all items need to be changed, but only some. Refer to the Gtk::Filter::Change documentation for details.

This function is intended for implementers of Gtk::Filter subclasses and should not be called from other functions.

Parameters

  change | How the filter changed.

## ◆ get_strictness()

Match Gtk::Filter::get_strictness | ( |  | ) |

Gets the known strictness of a filter.

If the strictness is not known, [enum@.nosp@m.Gtk..nosp@m.Filte.nosp@m.rMat.nosp@m.ch.so.nosp@m.me] is returned.

This value may change after emission of the signal_changed() signal.

This function is meant purely for optimization purposes. Filters can choose to omit implementing it, but Gtk::FilterListModel uses it.

Returns
  The strictness of self.

## ◆ get_strictness_vfunc()

virtual Match Gtk::Filter::get_strictness_vfunc | ( |  | ) |
| protectedvirtual

## ◆ get_type()

GType Gtk::Filter::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkFilter * Gtk::Filter::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkFilter * Gtk::Filter::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkFilter * Gtk::Filter::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ match()

bool Gtk::Filter::match | ( | const Glib::RefPtr< Glib::ObjectBase > & | item | ) |

Checks if the given item is matched by the filter or not.

Parameters

  item | The item to check.

Returns
  True if the filter matches the item.

## ◆ match_vfunc()

virtual bool Gtk::Filter::match_vfunc | ( | const Glib::RefPtr< Glib::ObjectBase > & | item | ) |
| protectedvirtual

## ◆ operator=()

Filter & Gtk::Filter::operator= | ( | Filter && | src | ) |
| noexcept

## ◆ signal_changed()

Glib::SignalProxy< void(Change)> Gtk::Filter::signal_changed | ( |  | ) |

Slot Prototype:
  void on_my_changed(Change change)

Flags: Run Last

Emitted whenever the filter changed.

Users of the filter should then check items again via Gtk::Filter::match().

Gtk::FilterListModel handles this signal automatically.

Depending on the change parameter, not all items need to be checked, but only some. Refer to the Gtk::Filter::Change documentation for details.

Parameters

  change | How the filter changed.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::Filter > wrap | ( | GtkFilter * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.